/*************************************************************/
/* Input the needed info for an em analysis.                 */
/* (C) COPYRIGHT 1986 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr23may87 */ 

#include "local.h"
#include <stdio.h>
#include <ctype.h>
#include <math.h>
#include <string.h>


#include "son.h"
#include "em.typ"

/* KRS char *strcpy(),*strncpy(); */

extern char prog_name[];

void met_name(),update_ref(),add_ann();
double atof();

#ifdef __STDC__
#define P_(A) A
#else   /* ANSI */
#define P_(A) ()
#endif

int add_p_port P_( ( int ipoly, int ipt, int ilev, int index, Rtyp zp[4], port_list *ports, int line_nu) );
int add_e_via P_( ( int ipoly, int ipt, int ilev, int typ, via_list *vias, int line_nu) );
int init_cir P_( ( Cir *cir, int Nlev) );
int init_ej P_( ( Box_info *Box) );
int init_sub_typ P_( ( Box_info *Box) );

Get_circuit_head(filename,in,Box,cir,Version,Str)  
char *filename;
FILE *in;
Box_info *Box;  
Cir *cir; 
char *Version;
char Str[];
/*************************************************************/
/* Input header information for .geo file 		     */
/* Returns:						     */
/*	1  - bad key					     */
/*	0  - read file properly & good key		     */
/*	-3 - No file present				     */
/*	-2 - unexpected end of file.			     */
/*	-1 - .geo file is of improper format		     */
/* (C) COPYRIGHT 1986 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* 10dec92jcr modified to allow both old and new via types*/
{
  int i,index,Ok,typ;
  char *Pos;
  int ipoly,ipt,ilev;
  Rtyp zp[4];

  Box->Bot.rdc = Box->Bot.rrf = 0.0;
  met_name("Ground Plane",&(Box->Bot));
  Box->Top.rdc = Box->Top.rrf = 0.0;
  met_name("Top Cover",&(Box->Top));

  /*Start reading the file*/
  *Str='\0';  
  while (*(Pos=Skip_blnks(Str))=='\0') {
	if (sFgets(Str,255,in)==NULL) {
		fprintf(stderr,"File \"%s\" does not contain a circuit.\n",filename);
		return(-1);
	}
  }

  while (strncmp(Pos,"NUM",3)!=0)
  { if (strncmp(Pos,"VER",3)==0) 
    { Pos = Next_field(Pos);
      strncpy(Version,Pos,5);
      Version[5] = '\0';
    } else if (strncmp(Pos,"LIC",3)==0)
    { Pos = Next_field(Pos);
        strncpy(Box->license_id,Pos,256);
    }
    else if (strncmp(Pos,"DAT",3)==0)
    { Pos = Next_field(Pos);
      strncpy(Box->xgeomdate,Pos,40);
    }
    else if (strncmp(Pos,"SYM",3)==0) Box->Xsym=1;
    else if (strncmp(Pos,"LEN",3)==0)
    { if (Box->Lcnv>0.0)
      { fprintf(stderr,"\nFile \"%s\", line %d: Multiple Length units in geometry file.\n",
		filename,Fgets_line_num() );
        return(-1);
      }
      Pos=Next_field(Pos);
      strncpy(Box->Lstr,Pos,6);
      Box->Lstr[6] = '\0';
      for (i=1; i<7; i++) if (isspace( *(Box->Lstr+i) )) *(Box->Lstr+i) = '\0';
      Box->Lcnv = fabs( atof(Next_field(Pos)) );
    }
    else if (strncmp(Pos,"REF",3)==0) 
    { if (Box->Lcnv<=0.0) { strcpy(Box->Lstr,"mils"); Box->Lcnv=0.0000254; }
      for (i=0; i<8; i++) {
	Pos = Next_field(Pos);
	Box->rref[i] = atof(Pos) * Box->Lcnv;
      }
    }
    else if (strncmp(Pos,"POR",3)==0)
    { if (Box->Num_levels<=0)
      { fprintf(stderr,"\nFile \"%s\", line %d: Ports must be after BOX line.\n",
		filename,Fgets_line_num() );
	return(-1);
      }
      Ok = sscanf(Next_field(Pos),"%d %d %d %d %lf %lf %lf %lf",
                  &ipoly,&ipt,&ilev,&index,zp,zp+1,zp+2,zp+3);
      if (Ok<3)
      { fprintf(stderr,"\nFile \"%s\", line %d: Port %d all of the parameters not specified.\n",filename,Fgets_line_num() ,cir->ports->n+1);  return(-1); }
      if ( ilev > cir->n - 1) {
	      fprintf(stderr,"\nFile \"%s\", line %d: Port %d level is too large.\n",filename,Fgets_line_num() ,cir->ports->n+1);
	      return(-1);
      }
      /*check for no port index listed*/
      if (Ok<4 || index==0) { index = cir->ports->n + 1; }
      if (Ok<5) zp[0] = 50.0;
      if (Ok<6) zp[1] = 0.0;
      if (Ok<7) zp[2] = 0.0;
      if (Ok<8) zp[3] = 0.0;
      add_p_port(ipoly,ipt,ilev,index,zp,cir->ports,Fgets_line_num() );
    }
    else if (strncmp(Pos,"VIA",3)==0 || strncmp(Pos,"EVIA",4)==0) 
    { if (Box->Num_levels<=0)
      { fprintf(stderr,"\nFile \"%s\", line %d: Vias must be after BOX line.\n",filename,Fgets_line_num() );
	return(-1);
      }
      typ = ( *Pos == 'E' ) ? VIA_EDGE : VIA_OLD;
      Ok = sscanf(Next_field(Pos),"%d %d %d",&ipoly,&ipt,&ilev);
      if (Ok<3)
      { fprintf(stderr,"\nFile \"%s\", line %d: Vias %d all of the parameters not specified.\n",filename,Fgets_line_num() ,cir->vias->n+1);  return(-1); }
      if ( ilev > cir->n - 1 ) {
	      fprintf(stderr,"\nFile \"%s\", line %d: Via %d level is too large.\n",filename,Fgets_line_num() ,cir->vias->n+1);
	      return(-1);
      }
      add_e_via(ipoly,ipt,ilev,typ,cir->vias,Fgets_line_num() );
    }
    else if (strncmp(Pos,"BOX",3)==0) 
    { if (Box->Lcnv<=0.0) { strcpy(Box->Lstr,"mils"); Box->Lcnv=0.0000254; }
      Pos = Next_field(Pos);
      Ok = Get_box_info(filename,in,Pos,Box);
      init_cir( cir,Box->Num_levels);
      if (Ok!=0) return(Ok);
    }
    else if (strncmp(Pos,"RES",3)==0) 
    { Pos = Next_field(Pos);
      Ok = Get_met_info(Pos,Box);
      if (Ok!=0) return(Ok);
    }
    else if (strncmp(Pos,"REN",3)==0) 
    { Pos = Next_field(Pos);
      Ok = Get_bon_info(filename,Pos,Box->met+Box->num_met-1);
      if (Ok!=0) return(Ok);
    }
    else if (strncmp(Pos,"BOT",3)==0) 
    { Pos = Next_field(Pos);
      Ok = Get_bot_info(Pos,Box);
      if (Ok!=0) return(Ok);
    }
    else if (strncmp(Pos,"BON",3)==0) 
    { Pos = Next_field(Pos);
      Ok = Get_bon_info(filename,Pos,&(Box->Bot) );
      if (Ok!=0) return(Ok);
    }
    else if (strncmp(Pos,"TOP",3)==0) 
    { Pos = Next_field(Pos);
      Ok = Get_top_info(Pos,Box);
      if (Ok!=0) return(Ok);
    }
    else if (strncmp(Pos,"TON",3)==0) 
    { Pos = Next_field(Pos);
      Ok = Get_bon_info(filename,Pos,&(Box->Top));
      if (Ok!=0) return(Ok);
    }
    else if (strncmp(Pos,"ANN",3)==0)
      add_ann(&(Box->ann),&(Box->num_ann),Next_field(Pos));
    else if ( *Pos!='\0' && *Pos!='!' )   /*Blank line or comment, do nothing*/
    { fprintf(stderr,"\nFile \"%s\", line %d: Unrecognized string in geometry file --\n%s\n",
	      filename,Fgets_line_num() ,Str);
      return(-1);
    }
    if( sFgets(Str,255,in) == NULL ) {
      fprintf(stderr,"\nFile \"%s\", line %d: Unexpected end of file in geometry file\n",filename,Fgets_line_num() );
      return(-2);
    }
    Pos = Skip_blnks(Str);
  }

  /*Do some error checking*/
  if (Box->Capn<=0)
  { fprintf(stderr,"\nMissing BOX information in \"%s\" file.\n",filename);
    return(-1);
  }
  init_sub_typ(Box);
  init_ej(Box);
  /*Generate integer reference planes*/
  update_ref(Box);
  
  return(0);
  
} /*Get_circuit*/

int Get_box_info(filename,in,Box_str,Box)  char *filename; FILE *in;
                              char *Box_str;   Box_info *Box;
/*************************************************************/
/* Box info in Str and in next lines.                        */
/* (C) COPYRIGHT 1986 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr31may87 */ 
{ int i,nitem;
  int Nlev;  /*Number of metalliztion levels*/
  Rtyp *H,*E,*M,*EL,*ML; /*substr. thickness, epsilon, mu, and loss*/
  char Str[256],*Pos;

  if (Box->Capn>0) /*Box information has already been specified*/
  { fprintf(stderr,"\nFile \"%s\", line %d: Multiple BOX information in geometry file.\n",
	    filename,Fgets_line_num() );
    return(-1);
  }
  Box->Capn = 0;
  Box->eeff = 0.0;
  sscanf(Box_str,"%d %lf %lf %d %d %d %lf",&Nlev,&Box->A,&Box->B,&Box->Capm,&Box->Capn,&Box->msub_per,&Box->eeff);
  if (Box->Capn==0) 
  { fprintf(stderr,"\nFile \"%s\", line %d: Incomplete BOX line in geo file.\n",
	    filename,Fgets_line_num() ); 
     return(-1); 
  }
  if (Nlev<1)
  { fprintf(stderr,"\nFile \"%s\", line %d: Number of metallization levels must be > 0.\n",
	    filename,Fgets_line_num() ); 
    return(-1); 
  }
  if ( Box->A <= 0.0 ) {
    fprintf(stderr,"\nFile \"%s\", line %d: BOX width must be greater than 0.\n",
	    filename,Fgets_line_num() ); 
    return(-1);
  }

  if ( Box->B <= 0.0 ) {
    fprintf(stderr,"\nFile \"%s\", line %d: BOX height must be greater than 0.\n",
	    filename,Fgets_line_num() ); 
    return(-1);
  }

  if ( Box->Capm < 6 ) {
    fprintf(stderr,"\nFile \"%s\", line %d: Not enough cells in the X direction.\n",
	    filename,Fgets_line_num() ); 
    return(-1);
  }

  if ( Box->Capn < 6 ) {
    fprintf(stderr,"\nFile \"%s\", line %d: Not enough cells in the Y direction.\n",
	    filename,Fgets_line_num() ); 
    return(-1);
  }

  if ( Box->msub_per <= 0 ) {
    fprintf(stderr,"\nFile \"%s\", line %d: Number of subsections per wavelength must be greater than 0.\n",
	    filename,Fgets_line_num() ); 
    return(-1);
  }

  Box->A *= Box->Lcnv;  Box->B *= Box->Lcnv;  Box->C = 0.0;
  Box->Num_levels = Nlev;
  Box->H = (Rtyp *)new( (Nlev+1)*sizeof(Rtyp) );
  Box->Eps = (Rtyp *)new( (Nlev+1)*sizeof(Rtyp) );
  Box->Mu = (Rtyp *)new( (Nlev+1)*sizeof(Rtyp) );
  Box->Eloss = (Rtyp *)new( (Nlev+1)*sizeof(Rtyp) );
  Box->Mloss = (Rtyp *)new( (Nlev+1)*sizeof(Rtyp) );

  for (i=0,H=Box->H,E=Box->Eps,M=Box->Mu,EL=Box->Eloss,ML=Box->Mloss; i<=Nlev; i++,H++,E++,M++,EL++,ML++)
  { if ( sFgets(Str,256,in)==NULL ) {
      fprintf(stderr,"\nFile \"%s\", line %d: Unexpected end of file in geometry file\n",filename,Fgets_line_num());
      return(-2);
    }
    while ( *(Pos=Skip_blnks(Str))=='!' || *Pos=='\0' ) if (sFgets(Str,255,in)==NULL) {
      fprintf(stderr,"\nFile \"%s\", line %d: Unexpected end of file in geometry file\n",filename,Fgets_line_num() );
      return(-2);
    }
    nitem = sscanf(Pos,"%lf %lf %lf %lf %lf",H,E,M,EL,ML);
    if (nitem<=1) {
      fprintf(stderr,"\nFile \"%s\", line %d: Insufficient number of levels defined.\n",filename,Fgets_line_num() );
      return(-2);
    }
    switch (nitem) /*Set up defaults*/
    { case 1 : *E = 1.0;
      case 2 : *M = 1.0;
      case 3 : *EL = 0.0;
      case 4 : *ML = 0.0;
    }
    *H *= Box->Lcnv;  *E *= EPSILON_0;  *M *= MU_0;
    if ( fabs(*EL)<1.0E-100 && fabs(*ML)<1.0E-100 ) { *EL = 0.0;  *ML= 0.0; }
    else Box->Lossless = 0;
    Box->C += *H;
  }
  return(0);
} /*Get_box_info*/

int
Get_bon_info(filename,str,metptr)  char *filename; char *str;  Met_type *metptr;
/*************************************************************/
/* Metallization attr and name for metptr.                    */
/* (C) COPYRIGHT 1986 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr14jul88 */ 
{ int temp;
 
  if (metptr==NULL)
  { fprintf(stderr,"\nFile \"%s\", line %d: No corresponding metallization for REN, TON or BON line.\n",filename,Fgets_line_num() );
    return(-1);
  }
  if (strlen(str)<=0) return(0);
  /*Read the attribute*/
  if ( sscanf(str,"%d",&temp)!=1 )
  { fprintf(stderr,"\nFile \"%s\", line %d: Bad BON, TON or REN line.\n",filename,Fgets_line_num() );
    return(-1);
  }
  metptr->attr = temp;

  str = Next_field(str);
  if (strlen(str)<=0) return(0);
  met_name(str,metptr);
  return(0);
} /*Get_bon_info*/

/*init_met is end point of ck sum for timeout*/
void
init_met(metptr)  Met_type *metptr;
/*************************************************************/
/* Set initial state for met info.                           */
/* (C) COPYRIGHT 1986 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr04aug89 */ 
{ metptr->name = NULL;
  metptr->rdc = metptr->rrf = metptr->xdc = 0.0;
  metptr->attr = 0;
} /*init_met*/

void
met_name(str,metptr)  Met_type *metptr;  char *str;
/*************************************************************/
/* Get resistivity info for the top plate.                   */
/* (C) COPYRIGHT 1986 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr04aug89 */ 
{ if (metptr->name) sFree((char *)metptr->name);
  metptr->name = NULL;
  if (str==NULL) return;
  metptr->name = (char *)new( (strlen(str)+1)*sizeof(char) );
  strcpy(metptr->name,str);
} /*met_name*/


Get_met_info(str,Box)  char *str;   Box_info *Box;
/*************************************************************/
/* Get resistivity info for the next metallization.           */
/* (C) COPYRIGHT 1986 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr30jun88 */ 
/* jcr01aug88 for two coef only model*/
{ char *pos,def_name[20];
  Rtyp temp;
  Met_type *metptr;
  
  Box->num_met++;
  Box->met = (Box->met) ? (Met_type *)rnew((char *)Box->met,Box->num_met*sizeof(Met_type))
                        : (Met_type *)new(sizeof(Met_type));
  metptr = Box->met + Box->num_met - 1;
  init_met(metptr);
  sprintf(def_name,"Met %d",Box->num_met);
  met_name(def_name,metptr);
  /*Set default attribute*/
  metptr->attr = Box->num_met;

  /*Read 0 - 4  coefficients*/
  pos = str;
  if (sscanf(pos,"%lf",&temp) == 1)
  { metptr->rdc = temp;  pos = Next_field(pos);
    if (sscanf(pos,"%lf",&temp) == 1)
    { metptr->rrf = temp;  pos = Next_field(pos);
      if (sscanf(pos,"%lf",&temp) == 1)
      { metptr->xdc = temp;
      }
    }
  }
  return(0);
} /*Get_met_info*/

Get_bot_info(str,Box)  char *str;   Box_info *Box;
/*************************************************************/
/* Get resistivity info for the bottom plate.                */
/* (C) COPYRIGHT 1986 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr30jun88 */ 
/* jcr01aug88 for two coef only model*/
{ char *pos;
  Rtyp temp;
  Met_type *metptr;
  
  metptr = &(Box->Bot);
  init_met(metptr);
  met_name("Ground Plane",metptr);

  /*Read 0 - 3 coefficients*/
  pos = str;
  if (sscanf(pos,"%lf",&temp) == 1)
  { metptr->rdc = temp;  pos = Next_field(pos);
    if (sscanf(pos,"%lf",&temp) == 1)
    { metptr->rrf = temp;  pos = Next_field(pos);
      if (sscanf(pos,"%lf",&temp) == 1)
      { metptr->xdc = temp; }
    }
  }
  if ( metptr->rdc>1.0e-30 || metptr->rrf>1.0e-30 ) Box->Lossless = 0;
  return(0);
} /*Get_bot_info*/

Get_top_info(str,Box)  char *str;   Box_info *Box;
/*************************************************************/
/* Get resistivity info for the top plate.                   */
/* (C) COPYRIGHT 1986 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr30jun88 */ 
/* jcr01aug88 for two coef only model*/
{ char *pos;
  Rtyp temp;
  Met_type *metptr;
  
  metptr = &(Box->Top);
  init_met(metptr);
  met_name("Top Cover",metptr);

  /*Read 0 - 3 coefficients*/
  pos = str;
  if (sscanf(pos,"%lf",&temp) == 1)
  { metptr->rdc = temp;  pos = Next_field(pos);
    if (sscanf(pos,"%lf",&temp) == 1)
    { metptr->rrf = temp;  pos = Next_field(pos);
      if (sscanf(pos,"%lf",&temp) == 1)
      { metptr->xdc = temp; }
    }
  }
  if ( metptr->rdc>1.0e-30 || metptr->rrf>1.0e-30 ) Box->Lossless = 0;
  return(0);
} /*Get_top_info*/

void
update_ref(Box) Box_info *Box;
/*************************************************************/
/* Generate integer reference planes.                        */
/* (C) COPYRIGHT 1989 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr21may89 */ 
{ Rtyp tmp;
  tmp = Box->Capm * Box->rref[0] / Box->A;
    Box->ref[0] = (tmp>=0.0) ? (intx(tmp)) : -(intx(-tmp));
  tmp = Box->Capm * Box->rref[1] / Box->A;
    Box->ref[1] = (tmp>=0.0) ? (intx(tmp)) : -(intx(-tmp));
  tmp = Box->Capn * Box->rref[2] / Box->B;
    Box->ref[2] = (tmp>=0.0) ? (inty(tmp)) : -(inty(-tmp));
  tmp = Box->Capn * Box->rref[3] / Box->B;
    Box->ref[3] = (tmp>=0.0) ? (inty(tmp)) : -(inty(-tmp));

  /*The remaining refs are for deleting transverse subs*/
  tmp = Box->Capm * Box->rref[4] / Box->A;  Box->ref[4] = intx(tmp);
  tmp = Box->Capm * Box->rref[5] / Box->A;  Box->ref[5] = intx(tmp);
  tmp = Box->Capn * Box->rref[6] / Box->B;  Box->ref[6] = inty(tmp);
  tmp = Box->Capn * Box->rref[7] / Box->B;  Box->ref[7] = inty(tmp);
} /*update_ref*/

void
add_ann(str_arrp,nump,str)  char ***str_arrp; int *nump;  char *str;
/*************************************************************/
/* Add a comment to the array of comments.                   */
/* (C) COPYRIGHT 1986 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr01jan88 */ 
{ (*nump)++;
  if (*str_arrp == NULL) *str_arrp = (char **)new( sizeof(*str_arrp) );
  else *str_arrp = (char **)rnew( (char *)*str_arrp , *nump * sizeof( *str_arrp ) );
  /*Remove any \n at end of string*/
  if (*(str+strlen(str)-1) == '\n') *(str+strlen(str)-1) = '\0';
  *( *str_arrp + *nump -1 ) = (char *)new( (1+strlen(str))*sizeof(char) );
  strcpy( *(*str_arrp + *nump -1 ), str);
} /*add_ann*/

init_box(Box)  Box_info *Box;
/*************************************************************/
/* Initialize information in Box to zero.                    */
/* (C) COPYRIGHT 1986 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr01jan88 */ 
{ int i;
  Box->file = NULL;
  strcpy(Box->license_id,"Not found");
  strcpy(Box->xgeomdate,"Unknown");
  Box->A = 0.0;  Box->B = 0.0;  Box->C = 0.0;
  Box->H = NULL;
  Box->Capm = 0;  Box->Capn = 0;
  Box->mat_size = 0;
  Box->quad_prec = 0;
  Box->qfmin = 0.0;
  Box->Num_levels = 0;
  Box->Xsym = 0; /*Default, no symmetry*/
  Box->Eps = NULL;  Box->Mu = NULL;
  Box->Eloss = NULL;  Box->Mloss = NULL;
  Box->met_loss = 0;
  Box->met_react = 0;
  Box->Lossless = 1;
  Box->num_met = 0;
  Box->met = NULL;
  init_met(&(Box->Bot));
  init_met(&(Box->Top));
  Box->rref[0] = 0.0;  Box->rref[1] = 0.0;
  Box->rref[2] = 0.0;  Box->rref[3] = 0.0;
  Box->ref[0] = 0;  Box->ref[1] = 0;
  Box->ref[2] = 0;  Box->ref[3] = 0;
  Box->sub = NULL;
  *(Box->Lstr) = '\0';
  Box->Lcnv = -1.0; /*See if it gets set*/
  Box->ann = NULL;
  Box->num_ann = 0;
  Box->num_ej = 0;
  Box->ej_loss = NULL;
  Box->msub_per = 20;
  Box->eeff = 0.0;
  Box->max_xinc = 1;
  Box->max_yinc = 1;
  Box->ckp_lev = 1;  /*Default, ck up/dwn for poly edges during sub*/
  Box->rm_reson = 0;
  for (i=0; i<3*NUM_RES; i++)
    Box->te_res[i] = Box->tm_res[i] = 0;
  Box->orphan = 0;
} /*init_box*/

